/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.100 Revision 1.141
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.100 2011/11/19 20:31:12 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.141 2012/12/31 06:29:42 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in
13 3|4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
13 28
14MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
16 31
17HOMEPAGE="http://qt.nokia.com/" 32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 39 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 40 ;;
41esac
20 42
21IUSE="aqua debug pch" 43IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 44[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 45[[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
25 IUSE+=" +exceptions"
26 46
27if version_is_at_least 4.7.99999999; then 47DEPEND="virtual/pkgconfig"
28 IUSE+=" c++0x qpa" 48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
29fi 50fi
30 51
31RDEPEND=" 52RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 53 !<x11-libs/qt-assistant-${PV}:4
33 !>x11-libs/qt-assistant-${PV}-r9999 54 !>x11-libs/qt-assistant-${PV}-r9999:4
55 !<x11-libs/qt-bearer-${PV}:4
56 !>x11-libs/qt-bearer-${PV}-r9999:4
34 !<x11-libs/qt-core-${PV} 57 !<x11-libs/qt-core-${PV}:4
35 !>x11-libs/qt-core-${PV}-r9999 58 !>x11-libs/qt-core-${PV}-r9999:4
36 !<x11-libs/qt-dbus-${PV} 59 !<x11-libs/qt-dbus-${PV}:4
37 !>x11-libs/qt-dbus-${PV}-r9999 60 !>x11-libs/qt-dbus-${PV}-r9999:4
38 !<x11-libs/qt-declarative-${PV} 61 !<x11-libs/qt-declarative-${PV}:4
39 !>x11-libs/qt-declarative-${PV}-r9999 62 !>x11-libs/qt-declarative-${PV}-r9999:4
40 !<x11-libs/qt-demo-${PV} 63 !<x11-libs/qt-demo-${PV}:4
41 !>x11-libs/qt-demo-${PV}-r9999 64 !>x11-libs/qt-demo-${PV}-r9999:4
42 !<x11-libs/qt-gui-${PV} 65 !<x11-libs/qt-gui-${PV}:4
43 !>x11-libs/qt-gui-${PV}-r9999 66 !>x11-libs/qt-gui-${PV}-r9999:4
44 !<x11-libs/qt-multimedia-${PV} 67 !<x11-libs/qt-multimedia-${PV}:4
45 !>x11-libs/qt-multimedia-${PV}-r9999 68 !>x11-libs/qt-multimedia-${PV}-r9999:4
46 !<x11-libs/qt-opengl-${PV} 69 !<x11-libs/qt-opengl-${PV}:4
47 !>x11-libs/qt-opengl-${PV}-r9999 70 !>x11-libs/qt-opengl-${PV}-r9999:4
71 !<x11-libs/qt-openvg-${PV}:4
72 !>x11-libs/qt-openvg-${PV}-r9999:4
48 !<x11-libs/qt-phonon-${PV} 73 !<x11-libs/qt-phonon-${PV}:4
49 !>x11-libs/qt-phonon-${PV}-r9999 74 !>x11-libs/qt-phonon-${PV}-r9999:4
50 !<x11-libs/qt-qt3support-${PV} 75 !<x11-libs/qt-qt3support-${PV}:4
51 !>x11-libs/qt-qt3support-${PV}-r9999 76 !>x11-libs/qt-qt3support-${PV}-r9999:4
52 !<x11-libs/qt-script-${PV} 77 !<x11-libs/qt-script-${PV}:4
53 !>x11-libs/qt-script-${PV}-r9999 78 !>x11-libs/qt-script-${PV}-r9999:4
54 !<x11-libs/qt-sql-${PV} 79 !<x11-libs/qt-sql-${PV}:4
55 !>x11-libs/qt-sql-${PV}-r9999 80 !>x11-libs/qt-sql-${PV}-r9999:4
56 !<x11-libs/qt-svg-${PV} 81 !<x11-libs/qt-svg-${PV}:4
57 !>x11-libs/qt-svg-${PV}-r9999 82 !>x11-libs/qt-svg-${PV}-r9999:4
58 !<x11-libs/qt-test-${PV} 83 !<x11-libs/qt-test-${PV}:4
59 !>x11-libs/qt-test-${PV}-r9999 84 !>x11-libs/qt-test-${PV}-r9999:4
60 !<x11-libs/qt-webkit-${PV} 85 !<x11-libs/qt-webkit-${PV}:4
61 !>x11-libs/qt-webkit-${PV}-r9999 86 !>x11-libs/qt-webkit-${PV}-r9999:4
62 !<x11-libs/qt-xmlpatterns-${PV} 87 !<x11-libs/qt-xmlpatterns-${PV}:4
63 !>x11-libs/qt-xmlpatterns-${PV}-r9999 88 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
64" 89"
65 90
66S=${WORKDIR}/${MY_P} 91S=${WORKDIR}/${MY_P}
67 92
68# @FUNCTION: qt4-build_pkg_setup 93# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 94# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 95# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 96qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73
74 # Protect users by not allowing downgrades between releases 97 # Protect users by not allowing downgrades between releases.
75 # Downgrading revisions within the same release should be allowed 98 # Downgrading revisions within the same release should be allowed.
76 if has_version '>'${CATEGORY}/${P}-r9999; then 99 if has_version ">${CATEGORY}/${P}-r9999:4"; then
77 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 100 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
78 eerror "Sanity check to keep you from breaking your system:" 101 eerror " *** Sanity check to keep you from breaking your system ***"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 102 eerror "Downgrading Qt is completely unsupported and will break your system!"
80 die "aborting to save your system" 103 die "aborting to save your system"
81 else 104 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 105 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 106 fi
84 fi
85
86 if [[ ${PN} == "qt-webkit" ]]; then
87 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
93 ewarn "For more info check out bug #307861"
94 echo
95 fi
96 eshopts_pop
97 fi 107 fi
98 108
99 PATH="${S}/bin${PATH:+:}${PATH}" 109 PATH="${S}/bin${PATH:+:}${PATH}"
100 if [[ ${CHOST} != *-darwin* ]]; then 110 if [[ ${CHOST} != *-darwin* ]]; then
101 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 111 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
106 # avoid extract failure. 116 # avoid extract failure.
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 117 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 118 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 119 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 120 fi
111
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!"
122 fi
123} 121}
122
123# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
124# @DEFAULT_UNSET
125# @DESCRIPTION:
126# Space-separated list including the directories that will be extracted from
127# Qt tarball.
124 128
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 129# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
130# @DEFAULT_UNSET
126# @DESCRIPTION: 131# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 132# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 133# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt
133# tarball
134 134
135# @FUNCTION: qt4-build_src_unpack 135# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 136# @DESCRIPTION:
137# Unpacks the sources 137# Unpacks the sources.
138qt4-build_src_unpack() { 138qt4-build_src_unpack() {
139 setqtenv 139 setqtenv
140 local unpack_p="${MY_P}" 140
141 case "${PV}" in 141 if ! version_is_at_least 4.1 $(gcc-version); then
142 4.8.0_*) 142 ewarn "Using a GCC version lower than 4.1 is not supported."
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 143 fi
144
145 if [[ ${PN} == qt-webkit ]]; then
146 eshopts_push -s extglob
147 if is-flagq '-g?(gdb)?([1-9])'; then
148 echo
149 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
150 ewarn "You may experience really long compilation times and/or increased memory usage."
151 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
152 ewarn "For more info check out https://bugs.gentoo.org/307861"
153 echo
154 fi
155 eshopts_pop
156 fi
157
158 case ${QT4_BUILD_TYPE} in
159 live)
160 git-2_src_unpack
144 ;; 161 ;;
162 release)
163 local tarball="${MY_P}.tar.gz" target= targets=
164 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
165 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
166 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
167 do
168 targets+="${MY_P}/${target} "
169 done
170
171 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
172 tar -xzf "${DISTDIR}/${tarball}" ${targets}
173 eend $? || die "failed to unpack"
174 ;;
145 esac 175 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
149 ${QT4_EXTRACT_DIRECTORIES}; do
150 targets+=" ${unpack_p}/${target}"
151 done
152
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
155 case "${PV}" in
156 4.8.0_*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 176}
162 177
163# @ECLASS-VARIABLE: PATCHES 178# @ECLASS-VARIABLE: PATCHES
179# @DEFAULT_UNSET
164# @DESCRIPTION: 180# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 181# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 182# This variable is expected to be defined in global scope of ebuild.
167# example: 183# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 184# src_prepare() phase.
169# ${FILESDIR}"/mypatch2.patch"
170# 185#
186# @CODE
187# PATCHES=( "${FILESDIR}/mypatch.patch"
188# "${FILESDIR}/patches_folder/" )
189# @CODE
171 190
172# @FUNCTION: qt4-build_src_prepare 191# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 192# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 193# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 194# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 195qt4-build_src_prepare() {
177 setqtenv 196 setqtenv
178 cd "${S}"
179 197
180 # fix qt 4.7 regression that skips -fvisibility=hidden 198 if [[ ${QT4_BUILD_TYPE} == live ]]; then
181 if version_is_at_least "4.7.0_beta1"; then 199 QTDIR="." ./bin/syncqt || die "syncqt failed"
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi 200 fi
186 201
187 if version_is_at_least "4.7"; then
188 # fix libX11 dependency on non X packages 202 # avoid X11 dependency in non-gui packages
189 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 203 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
190 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 204 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
191
192 qt_assistant_cleanup
193 fi
194 205
195 if use aqua; then 206 if use aqua; then
196 # provide a proper macx-g++-64 207 # provide a proper macx-g++-64
197 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 208 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
198 209
199 sed -e '/^CONFIG/s:app_bundle::' \ 210 sed -e '/^CONFIG/s:app_bundle::' \
200 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 211 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
201 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 212 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
202 fi 213 fi
203 214
204 if [[ ${PN} != qt-core ]]; then 215 if [[ ${PN} != qt-core ]]; then
205 skip_qmake_build 216 skip_qmake_build
206 skip_project_generation 217 skip_project_generation
207 symlink_binaries_to_buildtree 218 symlink_binaries_to_buildtree
208 fi 219 fi
209 220
210 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 221 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
211 # qmake bus errors with -O2 but -O3 works 222 # qmake bus errors with -O2 or -O3 but -O1 works
223 # Bug 373061
212 replace-flags -O2 -O3 224 replace-flags -O[23] -O1
213 fi 225 fi
214 226
215 # Bug 178652 227 # Bug 178652
216 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 228 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
217 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 229 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
218 append-flags -fno-gcse 230 append-flags -fno-gcse
219 fi 231 fi
220 232
221 if use_if_iuse c++0x; then 233 if use_if_iuse c++0x; then
222 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
223 ewarn "this is an official standard, some of the reverse dependencies"
224 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
225 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
226 ewarn "disabled."
227 append-flags -std=c++0x 234 append-cxxflags -std=c++0x
228 fi 235 fi
229 236
230 # Unsupported old gcc versions - hardened needs this :( 237 # Unsupported old gcc versions - hardened needs this :(
231 if [[ $(gcc-major-version) -lt 4 ]] ; then 238 if [[ $(gcc-major-version) -lt 4 ]]; then
232 ewarn "Appending -fno-stack-protector to CXXFLAGS" 239 ewarn "Appending -fno-stack-protector to CXXFLAGS"
233 append-cxxflags -fno-stack-protector 240 append-cxxflags -fno-stack-protector
234 # Bug 253127 241 # Bug 253127
235 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 242 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
236 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 243 -i mkspecs/common/g++.conf || die
237 fi 244 fi
238 245
239 # Bug 261632 246 # Bug 261632
240 if use ppc64; then 247 if use ppc64; then
241 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 248 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
242 append-flags -mminimal-toc 249 append-flags -mminimal-toc
243 fi 250 fi
244 251
245 # Bug 282984 && Bug 295530 252 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
246 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 253 sed -e "/^SYSTEM_VARIABLES=/i \
247 -i configure || die "sed qmake compilers failed" 254 CC='$(tc-getCC)'\n\
255 CXX='$(tc-getCXX)'\n\
256 CFLAGS='${CFLAGS}'\n\
257 CXXFLAGS='${CXXFLAGS}'\n\
258 LDFLAGS='${LDFLAGS}'\n\
259 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
260 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
261 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
262 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
263 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
264 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
265 -i configure \
266 || die "sed SYSTEM_VARIABLES failed"
248 267
249 # Bug 321335 268 # Respect CC, CXX, LINK and *FLAGS in config.tests
250 if version_is_at_least 4.6; then 269 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
251 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 270 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
252 xargs -0 \ 271 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
253 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \ 272 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
254 -i || die "sed test compilers failed" 273 || die "sed config.tests failed"
255 fi
256 274
257 # Bug 172219 275 # Bug 172219
258 sed -e "s:X11R6/::" \ 276 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
259 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
260 277
261 if [[ ${CHOST} == *-darwin* ]]; then 278 if [[ ${CHOST} == *-darwin* ]]; then
262 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 279 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
263 # crippled (by design) :/ 280 # crippled (by design) :/
281 local mac_gpp_conf=
282 if [[ -f mkspecs/common/mac-g++.conf ]]; then
283 # qt < 4.8 has mac-g++.conf
284 mac_gpp_conf="mkspecs/common/mac-g++.conf"
285 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
286 # qt >= 4.8 has g++-macx.conf
287 mac_gpp_conf="mkspecs/common/g++-macx.conf"
288 else
289 die "no known conf file for mac found"
290 fi
291 sed \
264 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 292 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
265 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 293 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
266 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 294 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
267 -e "s:-arch\s\w*::g" \ 295 -e "s:-arch\s\w*::g" \
268 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 296 -i ${mac_gpp_conf} \
297 || die "sed ${mac_gpp_conf} failed"
269 298
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 299 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 300 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 301 # pch). Additionally disable Xarch support.
302 local mac_gcc_confs="${mac_gpp_conf}"
303 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
304 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
305 fi
273 sed \ 306 sed \
274 -e "s:-arch i386::" \ 307 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \ 308 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \ 309 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \ 310 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \ 311 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 312 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 313 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 314 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 315 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 316 -i configure ${mac_gcc_confs} \
317 || die "sed -arch/-Xarch failed"
284 318
285 # On Snow Leopard don't fall back to 10.5 deployment target. 319 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 320 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 321 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 322 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 323 -i configure ${mac_gpp_conf} \
324 || die "sed deployment target failed"
290 fi 325 fi
291 fi 326 fi
292 327
293 # this one is needed for all systems with a separate -liconv, apart from 328 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv 329 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 330 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
296 sed \ 331 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
298 -i config.tests/unix/iconv/iconv.pro \ 332 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed on iconv.pro failed" 333 || die "sed iconv.pro failed"
300 fi 334 fi
301 335
302 # we need some patches for Solaris 336 # we need some patches for Solaris
303 sed -i \
304 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 337 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 338 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio 339 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 340 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # don't flirt with non-Prefix stuff, we're quite possessive 341 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 342 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 343 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 # strip predefined CFLAGS from qmake ( bug #312689 )
312 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
313 344
314 base_src_prepare 345 # apply patches
346 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
347 epatch_user
315} 348}
316 349
317# @FUNCTION: qt4-build_src_configure 350# @FUNCTION: qt4-build_src_configure
318# @DESCRIPTION: 351# @DESCRIPTION:
319# Default configure phase 352# Default configure phase
320qt4-build_src_configure() { 353qt4-build_src_configure() {
321 setqtenv 354 setqtenv
322 myconf="$(standard_configure_options) ${myconf}" 355
356 local conf="
357 -prefix ${QTPREFIXDIR}
358 -bindir ${QTBINDIR}
359 -libdir ${QTLIBDIR}
360 -docdir ${QTDOCDIR}
361 -headerdir ${QTHEADERDIR}
362 -plugindir ${QTPLUGINDIR}
363 -importdir ${QTIMPORTDIR}
364 -datadir ${QTDATADIR}
365 -translationdir ${QTTRANSDIR}
366 -sysconfdir ${QTSYSCONFDIR}
367 -examplesdir ${QTEXAMPLESDIR}
368 -demosdir ${QTDEMOSDIR}
369 -opensource -confirm-license
370 -shared -fast -largefile -stl -verbose
371 -nomake examples -nomake demos"
372
373 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
374 # $(tc-arch). Therefore we convert it to supported values.
375 case "$(tc-arch)" in
376 amd64|x64-*) conf+=" -arch x86_64" ;;
377 ppc-macos) conf+=" -arch ppc" ;;
378 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
379 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
380 x86-macos) conf+=" -arch x86" ;;
381 x86|x86-*) conf+=" -arch i386" ;;
382 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
383 hppa|sh) conf+=" -arch generic" ;;
384 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
385 esac
386
387 conf+=" -platform $(qt_mkspecs_dir)"
388
389 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
390
391 # debug/release
392 if use debug; then
393 conf+=" -debug"
394 else
395 conf+=" -release"
396 fi
397 conf+=" -no-separate-debug-info"
398
399 # exceptions USE flag
400 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
401
402 # disable rpath (bug 380415), except on prefix (bug 417169)
403 use prefix || conf+=" -no-rpath"
404
405 # precompiled headers don't work on hardened, where the flag is masked
406 conf+=" $(qt_use pch)"
407
408 # -reduce-relocations
409 # This flag seems to introduce major breakage to applications,
410 # mostly to be seen as a core dump with the message "QPixmap: Must
411 # construct a QApplication before a QPaintDevice" on Solaris.
412 # -- Daniel Vergien
413 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
323 414
324 # this one is needed for all systems with a separate -liconv, apart from 415 # this one is needed for all systems with a separate -liconv, apart from
325 # Darwin, for which the sources already cater for -liconv 416 # Darwin, for which the sources already cater for -liconv
326 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 417 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
327 myconf+=" -liconv" 418 conf+=" -liconv"
419 fi
328 420
329 if use_if_iuse glib; then 421 if use_if_iuse glib; then
330 # use -I, -L and -l from configure
331 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 422 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
332 # avoid the -pthread argument 423 # avoid the -pthread argument
333 myconf+=" ${glibflags//-pthread}" 424 conf+=" ${glibflags//-pthread}"
334 unset glibflags 425 unset glibflags
335 fi 426 fi
336 427
337 if use_if_iuse qpa; then 428 if use_if_iuse qpa; then
338 ewarn 429 echo
339 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 430 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
340 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 431 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
341 ewarn "disable it before reporting any bugs related to this useflag." 432 ewarn "disable it before reporting any bugs related to this useflag."
342 ewarn 433 echo
343 myconf+=" -qpa" 434 conf+=" -qpa"
344 fi 435 fi
345 436
346 if use aqua ; then 437 if use aqua; then
347 # On (snow) leopard use the new (frameworked) cocoa code. 438 # On (snow) leopard use the new (frameworked) cocoa code.
348 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 439 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
349 myconf+=" -cocoa -framework" 440 conf+=" -cocoa -framework"
441 # We need the source's headers, not the installed ones.
442 conf+=" -I${S}/include"
443 # Add hint for the framework location.
444 conf+=" -F${QTLIBDIR}"
350 445
351 # We are crazy and build cocoa + qt3support :-) 446 # We are crazy and build cocoa + qt3support :-)
352 if use qt3support; then 447 if use qt3support; then
353 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 448 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
354 -i configure 449 -i configure || die
355 fi 450 fi
356 451 else
357 # We need the source's headers, not the installed ones. 452 conf+=" -no-framework"
358 myconf+=" -I${S}/include"
359
360 # Add hint for the framework location.
361 myconf+=" -F${QTLIBDIR}"
362 fi 453 fi
363 else 454 else
364 # freetype2 include dir is non-standard, thus include it on configure 455 # freetype2 include dir is non-standard, thus pass it to configure
365 # use -I from configure
366 myconf+=" $(pkg-config --cflags freetype2)" 456 conf+=" $(pkg-config --cflags-only-I freetype2)"
367 fi 457 fi
368 458
369 # Disable SSE4.x, since auto-detection is currently broken 459 conf+=" ${myconf}"
370 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 460 myconf=
371 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
372 461
373 echo ./configure ${myconf} 462 echo ./configure ${conf}
374 ./configure ${myconf} || die "./configure failed" 463 ./configure ${conf} || die "./configure failed"
375 myconf=""
376 464
377 prepare_directories ${QT4_TARGET_DIRECTORIES} 465 prepare_directories ${QT4_TARGET_DIRECTORIES}
378} 466}
379 467
380# @FUNCTION: qt4-build_src_compile 468# @FUNCTION: qt4-build_src_compile
388 476
389# @FUNCTION: qt4-build_src_test 477# @FUNCTION: qt4-build_src_test
390# @DESCRIPTION: 478# @DESCRIPTION:
391# Runs tests only in target directories. 479# Runs tests only in target directories.
392qt4-build_src_test() { 480qt4-build_src_test() {
481 # QtMultimedia does not have any test suite (bug #332299)
482 [[ ${PN} == qt-multimedia ]] && return
483
393 for dir in ${QT4_TARGET_DIRECTORIES}; do 484 for dir in ${QT4_TARGET_DIRECTORIES}; do
394 emake -j1 check -C ${dir} 485 emake -j1 check -C ${dir}
395 done 486 done
396} 487}
397 488
398# @FUNCTION: fix_includes 489# @FUNCTION: fix_includes
399# @DESCRIPTION: 490# @DESCRIPTION:
400# For MacOSX we need to add some symlinks when frameworks are 491# For MacOS X we need to add some symlinks when frameworks are
401# being used, to avoid complications with some more or less stupid packages. 492# being used, to avoid complications with some more or less stupid packages.
402fix_includes() { 493fix_includes() {
403 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 494 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
495 local frw dest f h rdir
404 # Some packages tend to include <Qt/...> 496 # Some packages tend to include <Qt/...>
405 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 497 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
406 498
407 # Fake normal headers when frameworks are installed... eases life later on 499 # Fake normal headers when frameworks are installed... eases life later
408 local dest f 500 # on, make sure we use relative links though, as some ebuilds assume
501 # these dirs exist in src_install to add additional files
502 f=${QTHEADERDIR}
503 h=${QTLIBDIR}
504 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
505 f=${f#*/}
506 h=${h#*/}
507 done
508 rdir=${h}
509 f="../"
510 while [[ ${h} == */* ]] ; do
511 f="${f}../"
512 h=${h#*/}
513 done
514 rdir="${f}${rdir}"
515
409 for frw in "${D}${QTLIBDIR}"/*.framework; do 516 for frw in "${D}${QTLIBDIR}"/*.framework; do
410 [[ -e "${frw}"/Headers ]] || continue 517 [[ -e "${frw}"/Headers ]] || continue
411 f=$(basename ${frw}) 518 f=$(basename ${frw})
412 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 519 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 520 dosym "${rdir}"/${f}/Headers "${dest}"
414 521
415 # Link normal headers as well. 522 # Link normal headers as well.
416 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 523 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
417 h=$(basename ${hdr}) 524 h=$(basename ${hdr})
418 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 525 dosym "../${rdir}"/${f}/Headers/${h} \
526 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
419 done 527 done
420 done 528 done
421 fi 529 fi
422} 530}
423 531
424# @FUNCTION: qt4-build_src_install 532# @FUNCTION: qt4-build_src_install
425# @DESCRIPTION: 533# @DESCRIPTION:
426# Perform the actual installation including some library fixes. 534# Perform the actual installation including some library fixes.
427qt4-build_src_install() { 535qt4-build_src_install() {
428 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
429 setqtenv 536 setqtenv
430 537
431 install_directories ${QT4_TARGET_DIRECTORIES} 538 install_directories ${QT4_TARGET_DIRECTORIES}
432 install_qconfigs 539 install_qconfigs
433 fix_library_files 540 fix_library_files
434 fix_includes 541 fix_includes
435 542
436 # remove .la files since we are building only shared Qt libraries 543 # remove .la files since we are building only shared libraries
437 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 544 prune_libtool_files
438} 545}
439 546
440# @FUNCTION: setqtenv 547# @FUNCTION: setqtenv
548# @INTERNAL
441setqtenv() { 549setqtenv() {
442 # Set up installation directories 550 # Set up installation directories
443 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
444 QTPREFIXDIR=${EPREFIX}/usr 551 QTPREFIXDIR=${EPREFIX}/usr
445 QTBINDIR=${EPREFIX}/usr/bin 552 QTBINDIR=${QTPREFIXDIR}/bin
446 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 553 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
447 QMAKE_LIBDIR_QT=${QTLIBDIR}
448 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 554 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
449 QTDATADIR=${EPREFIX}/usr/share/qt4
450 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 555 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
451 QTHEADERDIR=${EPREFIX}/usr/include/qt4 556 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
452 QTPLUGINDIR=${QTLIBDIR}/plugins 557 QTPLUGINDIR=${QTLIBDIR}/plugins
558 QTIMPORTDIR=${QTLIBDIR}/imports
559 QTDATADIR=${QTPREFIXDIR}/share/qt4
560 QTTRANSDIR=${QTDATADIR}/translations
453 QTSYSCONFDIR=${EPREFIX}/etc/qt4 561 QTSYSCONFDIR=${EPREFIX}/etc/qt4
454 QTTRANSDIR=${QTDATADIR}/translations
455 QTEXAMPLESDIR=${QTDATADIR}/examples 562 QTEXAMPLESDIR=${QTDATADIR}/examples
456 QTDEMOSDIR=${QTDATADIR}/demos 563 QTDEMOSDIR=${QTDATADIR}/demos
457 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 564 QMAKE_LIBDIR_QT=${QTLIBDIR}
565
458 PLATFORM=$(qt_mkspecs_dir) 566 PLATFORM=$(qt_mkspecs_dir)
459
460 unset QMAKESPEC 567 unset QMAKESPEC
461}
462 568
463# @FUNCTION: standard_configure_options 569 export XDG_CONFIG_HOME="${T}"
464# @DESCRIPTION:
465# Sets up some standard configure options, like libdir (if necessary), whether
466# debug info is wanted or not.
467standard_configure_options() {
468 local myconf=
469
470 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
471
472 # Disable visibility explicitly if gcc version isn't 4
473 if [[ $(gcc-major-version) -lt 4 ]]; then
474 myconf+=" -no-reduce-exports"
475 fi
476
477 # precompiled headers doesn't work on hardened, where the flag is masked.
478 myconf+=" $(qt_use pch)"
479
480 if use debug; then
481 myconf+=" -debug"
482 else
483 myconf+=" -release"
484 fi
485 myconf+=" -no-separate-debug-info"
486
487 use aqua && myconf+=" -no-framework"
488
489 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
490 # $(tc-arch). Therefore we convert it to supported values.
491 case "$(tc-arch)" in
492 amd64|x64-*) myconf+=" -arch x86_64" ;;
493 ppc-macos) myconf+=" -arch ppc" ;;
494 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
495 sparc|sparc-*) myconf+=" -arch sparc" ;;
496 x86-macos) myconf+=" -arch x86" ;;
497 x86|x86-*) myconf+=" -arch i386" ;;
498 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
499 hppa|sh) myconf+=" -arch generic" ;;
500 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
501 esac
502
503 # exceptions USE flag
504 local exceptions="-exceptions"
505 in_iuse exceptions && exceptions="$(qt_use exceptions)"
506
507 # note about -reduce-relocations:
508 # That flag seems to introduce major breakage to applications,
509 # mostly to be seen as a core dump with the message "QPixmap: Must
510 # construct a QApplication before a QPaintDevice" on Solaris
511 # -- Daniel Vergien
512 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
513
514 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
515 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
516 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
517 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
518 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
519 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
520 ${exceptions}
521 -nomake examples -nomake demos"
522
523 echo "${myconf}"
524} 570}
525 571
526# @FUNCTION: prepare_directories 572# @FUNCTION: prepare_directories
527# @USAGE: < directories > 573# @USAGE: < directories >
574# @INTERNAL
528# @DESCRIPTION: 575# @DESCRIPTION:
529# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 576# Generates Makefiles for the given list of directories.
530prepare_directories() { 577prepare_directories() {
578 # avoid running over the maximum argument number, bug #299810
579 {
580 echo "${S}"/mkspecs/common/*.conf
581 find "${S}" -name '*.pr[io]'
582 } | xargs sed -i \
583 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
584 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
585 || die
586
531 for x in "$@"; do 587 for x in "$@"; do
532 pushd "${S}"/${x} >/dev/null 588 pushd "${S}"/${x} >/dev/null || die
533 einfo "Running qmake in: ${x}" 589 einfo "Running qmake in: ${x}"
534 # avoid running over the maximum argument number, bug #299810 590 "${S}"/bin/qmake \
535 { 591 "LIBS+=-L${QTLIBDIR}" \
536 echo "${S}"/mkspecs/common/*.conf 592 "CONFIG+=nostrip" \
537 find "${S}" -name '*.pr[io]' 593 || die "qmake failed"
538 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
539 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
540 popd >/dev/null 594 popd >/dev/null || die
541 done 595 done
542} 596}
543
544 597
545# @FUNCTION: build_directories 598# @FUNCTION: build_directories
546# @USAGE: < directories > 599# @USAGE: < directories >
600# @INTERNAL
547# @DESCRIPTION: 601# @DESCRIPTION:
548# Compiles the code in $QT4_TARGET_DIRECTORIES 602# Compiles the code in the given list of directories.
549build_directories() { 603build_directories() {
550 for x in "$@"; do 604 for x in "$@"; do
551 pushd "${S}"/${x} >/dev/null 605 pushd "${S}"/${x} >/dev/null || die
606 emake \
607 AR="$(tc-getAR) cqs" \
552 emake CC="$(tc-getCC)" \ 608 CC="$(tc-getCC)" \
553 CXX="$(tc-getCXX)" \ 609 CXX="$(tc-getCXX)" \
554 LINK="$(tc-getCXX)" || die "emake failed" 610 LINK="$(tc-getCXX)" \
611 RANLIB=":" \
612 STRIP=":" \
613 || die "emake failed"
555 popd >/dev/null 614 popd >/dev/null || die
556 done 615 done
557} 616}
558 617
559# @FUNCTION: install_directories 618# @FUNCTION: install_directories
560# @USAGE: < directories > 619# @USAGE: < directories >
620# @INTERNAL
561# @DESCRIPTION: 621# @DESCRIPTION:
562# run emake install in the given directories, which are separated by spaces 622# Runs emake install in the given directories, which are separated by spaces.
563install_directories() { 623install_directories() {
564 for x in "$@"; do 624 for x in "$@"; do
565 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 625 pushd "${S}"/${x} >/dev/null || die
566 emake INSTALL_ROOT="${D}" install || die "emake install failed" 626 emake INSTALL_ROOT="${D}" install || die "emake install failed"
567 popd >/dev/null || die "Can't popd from ${S}/${x}" 627 popd >/dev/null || die
568 done 628 done
569} 629}
570 630
571# @ECLASS-VARIABLE: QCONFIG_ADD 631# @ECLASS-VARIABLE: QCONFIG_ADD
572# @DESCRIPTION: 632# @DESCRIPTION:
582# @DESCRIPTION: 642# @DESCRIPTION:
583# List variables that should be defined at the top of QtCore/qconfig.h 643# List variables that should be defined at the top of QtCore/qconfig.h
584: ${QCONFIG_DEFINE:=} 644: ${QCONFIG_DEFINE:=}
585 645
586# @FUNCTION: install_qconfigs 646# @FUNCTION: install_qconfigs
647# @INTERNAL
587# @DESCRIPTION: 648# @DESCRIPTION:
588# Install gentoo-specific mkspecs configurations 649# Install gentoo-specific mkspecs configurations.
589install_qconfigs() { 650install_qconfigs() {
590 local x 651 local x
591 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 652 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
592 for x in QCONFIG_ADD QCONFIG_REMOVE; do 653 for x in QCONFIG_ADD QCONFIG_REMOVE; do
593 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 654 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
604 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 665 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
605 fi 666 fi
606} 667}
607 668
608# @FUNCTION: generate_qconfigs 669# @FUNCTION: generate_qconfigs
670# @INTERNAL
609# @DESCRIPTION: 671# @DESCRIPTION:
610# Generates gentoo-specific configurations 672# Generates gentoo-specific qconfig.{h,pri}.
611generate_qconfigs() { 673generate_qconfigs() {
612 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 674 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
613 local x qconfig_add qconfig_remove qconfig_new 675 local x qconfig_add qconfig_remove qconfig_new
614 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 676 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
615 [[ -f ${x} ]] || continue 677 [[ -f ${x} ]] || continue
616 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 678 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
617 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 679 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
664 fi 726 fi
665} 727}
666 728
667# @FUNCTION: qt4-build_pkg_postrm 729# @FUNCTION: qt4-build_pkg_postrm
668# @DESCRIPTION: 730# @DESCRIPTION:
669# Generate configurations when the package is completely removed 731# Regenerate configuration when the package is completely removed.
670qt4-build_pkg_postrm() { 732qt4-build_pkg_postrm() {
671 generate_qconfigs 733 generate_qconfigs
672} 734}
673 735
674# @FUNCTION: qt4-build_pkg_postinst 736# @FUNCTION: qt4-build_pkg_postinst
675# @DESCRIPTION: 737# @DESCRIPTION:
676# Generate configuration, plus throws a message about possible 738# Regenerate configuration, plus throw a message about possible
677# breakages and proposed solutions. 739# breakages and proposed solutions.
678qt4-build_pkg_postinst() { 740qt4-build_pkg_postinst() {
679 generate_qconfigs 741 generate_qconfigs
680} 742}
681 743
682# @FUNCTION: skip_qmake_build 744# @FUNCTION: skip_qmake_build
745# @INTERNAL
683# @DESCRIPTION: 746# @DESCRIPTION:
684# Don't need to build qmake, as it's already installed from qt-core 747# Patches configure to skip qmake compilation, as it's already installed by qt-core.
685skip_qmake_build() { 748skip_qmake_build() {
686 # Don't need to build qmake, as it's already installed from qt-core
687 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed" 749 sed -i -e "s:if true:if false:g" "${S}"/configure || die
688} 750}
689 751
690# @FUNCTION: skip_project_generation 752# @FUNCTION: skip_project_generation
753# @INTERNAL
691# @DESCRIPTION: 754# @DESCRIPTION:
692# Exit the script early by throwing in an exit before all of the .pro files are scanned 755# Exit the script early by throwing in an exit before all of the .pro files are scanned.
693skip_project_generation() { 756skip_project_generation() {
694 # Exit the script early by throwing in an exit before all of the .pro files are scanned
695 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 757 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
696 -i "${S}"/configure || die "sed failed"
697} 758}
698 759
699# @FUNCTION: symlink_binaries_to_buildtree 760# @FUNCTION: symlink_binaries_to_buildtree
761# @INTERNAL
700# @DESCRIPTION: 762# @DESCRIPTION:
701# Symlink generated binaries to buildtree so they can be used during compilation 763# Symlinks generated binaries to buildtree, so they can be used during compilation time.
702# time
703symlink_binaries_to_buildtree() { 764symlink_binaries_to_buildtree() {
704 for bin in qmake moc uic rcc; do 765 for bin in qmake moc uic rcc; do
705 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed" 766 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
706 done 767 done
707} 768}
708 769
709# @FUNCTION: fix_library_files 770# @FUNCTION: fix_library_files
771# @INTERNAL
710# @DESCRIPTION: 772# @DESCRIPTION:
711# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 773# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
712# moves the *.pc-files into the pkgconfig directory 774# moves the *.pc files into the pkgconfig directory.
713fix_library_files() { 775fix_library_files() {
776 local libfile
714 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 777 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
715 if [[ -e ${libfile} ]]; then 778 if [[ -e ${libfile} ]]; then
716 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed" 779 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
717 fi 780 fi
718 done 781 done
719 782
720 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 783 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
721 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 784 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
722 if [[ -e ${libfile} ]]; then 785 if [[ -e ${libfile} ]]; then
723 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed" 786 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
724 787
725 # Move .pc files into the pkgconfig directory 788 # Move .pc files into the pkgconfig directory
726 dodir ${QTPCDIR#${EPREFIX}} 789 dodir ${QTPCDIR#${EPREFIX}}
727 mv ${libfile} "${D}"/${QTPCDIR}/ \ 790 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
728 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
729 fi 791 fi
730 done 792 done
731 793
732 # Don't install an empty directory 794 # Don't install an empty directory
733 rmdir "${D}"/${QTLIBDIR}/pkgconfig 795 rmdir "${D}"/${QTLIBDIR}/pkgconfig
734} 796}
735 797
736# @FUNCTION: qt_use 798# @FUNCTION: qt_use
737# @USAGE: < flag > [ feature ] [ enableval ] 799# @USAGE: < flag > [ feature ] [ enableval ]
738# @DESCRIPTION: 800# @DESCRIPTION:
739# This will echo "${enableval}-${feature}" if <flag> is enabled, or 801# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
740# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 802# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
741# will be used for that. If [enableval] is not specified, it omits the 803# will be used for that. If [enableval] is not specified, it omits the
742# assignment-part 804# "-${enableval}" part.
743qt_use() { 805qt_use() {
744 local flag=$1 806 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
745 local feature=$1
746 local enableval=
747
748 [[ -n $2 ]] && feature=$2
749 [[ -n $3 ]] && enableval=-$3
750
751 if use ${flag}; then
752 echo "${enableval}-${feature}"
753 else
754 echo "-no-${feature}"
755 fi
756} 807}
757 808
758# @FUNCTION: qt_mkspecs_dir 809# @FUNCTION: qt_mkspecs_dir
759# @RETURN: the specs-directory w/o path 810# @RETURN: the specs-directory w/o path
760# @DESCRIPTION: 811# @DESCRIPTION:
761# Allows us to define which mkspecs dir we want to use. 812# Allows us to define which mkspecs dir we want to use.
762qt_mkspecs_dir() { 813qt_mkspecs_dir() {
763 # Allows us to define which mkspecs dir we want to use.
764 local spec 814 local spec=
765 815
766 case ${CHOST} in 816 case "${CHOST}" in
767 *-freebsd*|*-dragonfly*) 817 *-freebsd*|*-dragonfly*)
768 spec=freebsd ;; 818 spec=freebsd ;;
769 *-openbsd*) 819 *-openbsd*)
770 spec=openbsd ;; 820 spec=openbsd ;;
771 *-netbsd*) 821 *-netbsd*)
782 *-solaris*) 832 *-solaris*)
783 spec=solaris ;; 833 spec=solaris ;;
784 *-linux-*|*-linux) 834 *-linux-*|*-linux)
785 spec=linux ;; 835 spec=linux ;;
786 *) 836 *)
787 die "Unknown CHOST, no platform chosen" 837 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
788 esac 838 esac
789 839
790 CXX=$(tc-getCXX) 840 case "$(tc-getCXX)" in
791 if [[ ${CXX} == *g++* ]]; then 841 *g++*)
792 spec+=-g++ 842 spec+=-g++ ;;
793 elif [[ ${CXX} == *icpc* ]]; then 843 *icpc*)
794 spec+=-icc 844 spec+=-icc ;;
795 else 845 *)
796 die "Unknown compiler '${CXX}'" 846 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
797 fi 847 esac
798 if [[ -n ${LIBDIR/lib} ]]; then
799 spec+=-${LIBDIR/lib}
800 fi
801 848
802 # Add -64 for 64bit profiles 849 # Add -64 for 64bit profiles
803 if use x64-freebsd || 850 if use x64-freebsd ||
804 use amd64-linux || 851 use amd64-linux ||
805 use x64-macos || 852 use x64-macos ||
810 fi 857 fi
811 858
812 echo "${spec}" 859 echo "${spec}"
813} 860}
814 861
815# @FUNCTION: qt_assistant_cleanup
816# @RETURN: nothing
817# @DESCRIPTION:
818# Tries to clean up tools.pro for qt-assistant ebuilds.
819# Meant to be called in src_prepare().
820# Since Qt 4.7.4 this function is a no-op.
821qt_assistant_cleanup() {
822 # apply patching to qt-assistant ebuilds only
823 [[ ${PN} != "qt-assistant" ]] && return
824
825 # no longer needed for 4.7.4 and later
826 version_is_at_least "4.7.4" && return
827
828 # different versions (and branches...) may need different handling,
829 # add a case if you need special handling
830 case "${MY_PV_EXTRA}" in
831 *kde-qt*)
832 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
833 -e "/mac/,/^embedded.*makeqpf$/d" \
834 -i tools/tools.pro || die "patching tools.pro failed"
835 ;;
836 *)
837 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
838 -e "/mac/,/^embedded.*makeqpf$/d" \
839 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
840 -i tools/tools.pro || die "patching tools.pro failed"
841 ;;
842 esac
843}
844
845# @FUNCTION: qt_nolibx11 862# @FUNCTION: qt_nolibx11
846# @RETURN: nothing 863# @INTERNAL
847# @DESCRIPTION: 864# @DESCRIPTION:
848# Ignore X11 tests for packages that don't need X libraries installed 865# Ignore X11 tests for packages that don't need X libraries installed.
849qt_nolibx11() { 866qt_nolibx11() {
850 einfo "Removing X11 check to allow X-less compilation"
851 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 867 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
852 die "x11 check sed failed" 868 die "x11 check sed failed"
853} 869}
854 870
855EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 871EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.100  
changed lines
  Added in v.1.141

  ViewVC Help
Powered by ViewVC 1.1.20